unit uFrmThread008;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, Vcl.Grids, Vcl.DBGrids, Vcl.StdCtrls, uConnThread;

type
  TFrmThread008 = class(TForm)
    DBGrid1: TDBGrid;
    memMsg: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    memInfo: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
    procedure DispMsg(AMsg: string);
    procedure DispThreadMsg(AMsg: string);
    procedure OnConnStatus(Sender: TConnThread; AStatus: TConnStatus);
  public
    { Public declarations }
  end;

var
  FrmThread008: TFrmThread008;

implementation

{$R *.dfm}

uses uDMMain;

{ TFrmThread008 }

procedure TFrmThread008.Button1Click(Sender: TObject);
begin
  DMMain.ADOConn.Close;
  DMMain.ADOConn.ConnectionString := strConnOK;
  DMMain.qrMSG.Open;
end;

procedure TFrmThread008.Button2Click(Sender: TObject);
begin
  DMMain.ADOConn.Close;
  DMMain.ADOConn.ConnectionString := strConnErr;
  Sleep(5000); // ģʱĵȴʱ
  DMMain.qrMSG.Open;
end;

procedure TFrmThread008.Button3Click(Sender: TObject);
var
  BThread: TConnThread;
begin
  // 治
  DispMsg('߳ݿ..');
  BThread := TConnThread.Create(true);
  BThread.ConnStr := strConnOK;
  BThread.OnConnStats := self.OnConnStatus;
  BThread.Start;
end;

procedure TFrmThread008.Button4Click(Sender: TObject);
var
  BThread: TConnThread;
begin
  // 治
  DispMsg('߳ݿ..');
  BThread := TConnThread.Create(true);
  BThread.ConnStr := strConnErr;
  BThread.OnConnStats := self.OnConnStatus;
  BThread.Start;
end;

procedure TFrmThread008.DispMsg(AMsg: string);
begin
  memMsg.Lines.Add(AMsg);
end;

procedure TFrmThread008.DispThreadMsg(AMsg: string);
begin
  TThread.Synchronize(nil,
    procedure
    begin
      DispMsg(AMsg);
    end);
end;

procedure TFrmThread008.OnConnStatus(Sender: TConnThread; AStatus: TConnStatus);
begin
  DispThreadMsg('Msg:' + Sender.Msg);

  if AStatus = csOK then
  begin
  end
  else if AStatus = csErr then
  begin
    DispThreadMsg('Ӵ!');
  end;

end;

end.
