unit uConnThread;

interface

uses
  classes, SysUtils;

Type

  TConnThread = class;

  TConnStatus = (csOK, csErr);

  TOnConnStatus = procedure(Sender: TConnThread; AStatus: TConnStatus) of object;

  TConnThread = class(TThread)
  protected
    procedure Execute; override;
  public
    ConnStr: string;
    OnConnStats: TOnConnStatus;
    Msg: string;
  end;

implementation

{ TConnThread }
uses
  uDMMain, ActiveX;

procedure TConnThread.Execute;
begin
  inherited;
  CoInitialize(nil); // ߳гʼ com,Ҫ ado ߳УҪ䡣
  try

    DMMain.ADOConn.Close;
    DMMain.ADOConn.ConnectionString := ConnStr;

    sleep(5000); //ģʱ

    DMMain.qrMSG.Open;
    Msg := 'ӳɹ';

    if Assigned(OnConnStats) then
      OnConnStats(self, csOK);

  except
    on e: Exception do
    begin
      Msg := e.Message;

      if Assigned(OnConnStats) then
        OnConnStats(self, csErr);

    end;
  end;

  CoUninitialize; // һӦͷ
end;

end.
